Index: /trunk/sources/HeuristicLab.Core.Views/3.3/OperatorGraphView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/OperatorGraphView.cs	(revision 3360)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/OperatorGraphView.cs	(revision 3361)
@@ -31,5 +31,5 @@
   /// </summary>
   [View("OperatorGraph View (Tree)",ShowInViewHost=true)]
-  [Content(typeof(OperatorGraph), true)]
+  [Content(typeof(OperatorGraph), false)]
   public partial class OperatorGraphView : ItemView {
     /// <summary>
Index: /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ViewHost.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ViewHost.cs	(revision 3360)
+++ /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ViewHost.cs	(revision 3361)
@@ -63,4 +63,5 @@
           viewContextMenuStrip.Item = content;
           cachedViews.Clear();
+          this.viewsLabel.Enabled = value != null;
           Initialize();
         }
@@ -73,5 +74,6 @@
         this.SuspendRepaint();
         base.Enabled = value;
-        this.viewsLabel.Enabled = value;
+        if (Content != null && value)
+          this.viewsLabel.Enabled = value;
         this.ResumeRepaint(true);
       }
@@ -113,7 +115,7 @@
 
       if (Content != null) {
-        if (viewContextMenuStrip.Items.Count == 0) 
+        if (viewContextMenuStrip.Items.Count == 0)
           messageLabel.Visible = true;
-         else 
+        else
           viewsLabel.Visible = true;
 
@@ -140,5 +142,5 @@
       UpdateActiveMenuItem();
       cachedViews.Clear();
-      Control view = (Control)MainFormManager.CreateView(viewType, Content,ReadOnly);
+      Control view = (Control)MainFormManager.CreateView(viewType, Content, ReadOnly);
       cachedViews.Add(viewType, ((IView)view));
       view.Dock = DockStyle.Fill;
@@ -168,5 +170,5 @@
 
     private void viewsLabel_DoubleClick(object sender, EventArgs e) {
-      MainFormManager.CreateView(viewType, Content,ReadOnly).Show();
+      MainFormManager.CreateView(viewType, Content, ReadOnly).Show();
     }
 
Index: /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphView.cs	(revision 3360)
+++ /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphView.cs	(revision 3361)
@@ -38,5 +38,5 @@
 namespace HeuristicLab.Operators.Views.GraphVisualization {
   [View("OperatorGraph View (Chart)")]
-  [Content(typeof(OperatorGraph), false)]
+  [Content(typeof(OperatorGraph), true)]
   public partial class OperatorGraphView : ContentView {
     public OperatorGraphView() {
@@ -93,5 +93,4 @@
         graphVisualizationInfoView.ReadOnly = true;
         connectButton.Enabled = false;
-        
       } else {
         selectButton.Enabled = true;
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.Designer.cs	(revision 3360)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.Designer.cs	(revision 3361)
@@ -45,4 +45,5 @@
     /// </summary>
     private void InitializeComponent() {
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(EngineAlgorithmView));
       this.engineLabel = new System.Windows.Forms.Label();
       this.createUserDefinedAlgorithmButton = new System.Windows.Forms.Button();
@@ -50,4 +51,9 @@
       this.engineTabPage = new System.Windows.Forms.TabPage();
       this.engineViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.operatorGraphTabPage = new System.Windows.Forms.TabPage();
+      this.saveOperatorGraphButton = new System.Windows.Forms.Button();
+      this.openOperatorGraphButton = new System.Windows.Forms.Button();
+      this.newOperatorGraphButton = new System.Windows.Forms.Button();
+      this.operatorGraphViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
       this.tabControl.SuspendLayout();
       this.parametersTabPage.SuspendLayout();
@@ -58,13 +64,16 @@
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.engineTabPage.SuspendLayout();
+      this.operatorGraphTabPage.SuspendLayout();
       this.SuspendLayout();
       // 
       // tabControl
       // 
+      this.tabControl.Controls.Add(this.operatorGraphTabPage);
       this.tabControl.Controls.Add(this.engineTabPage);
       this.tabControl.Size = new System.Drawing.Size(713, 467);
+      this.tabControl.Controls.SetChildIndex(this.engineTabPage, 0);
+      this.tabControl.Controls.SetChildIndex(this.operatorGraphTabPage, 0);
       this.tabControl.Controls.SetChildIndex(this.runsTabPage, 0);
       this.tabControl.Controls.SetChildIndex(this.resultsTabPage, 0);
-      this.tabControl.Controls.SetChildIndex(this.engineTabPage, 0);
       this.tabControl.Controls.SetChildIndex(this.problemTabPage, 0);
       this.tabControl.Controls.SetChildIndex(this.parametersTabPage, 0);
@@ -187,5 +196,5 @@
       this.engineComboBox.Location = new System.Drawing.Point(55, 6);
       this.engineComboBox.Name = "engineComboBox";
-      this.engineComboBox.Size = new System.Drawing.Size(644, 21);
+      this.engineComboBox.Size = new System.Drawing.Size(610, 21);
       this.engineComboBox.TabIndex = 1;
       this.engineComboBox.SelectedIndexChanged += new System.EventHandler(this.engineComboBox_SelectedIndexChanged);
@@ -212,7 +221,67 @@
       this.engineViewHost.Location = new System.Drawing.Point(6, 33);
       this.engineViewHost.Name = "engineViewHost";
-      this.engineViewHost.Size = new System.Drawing.Size(693, 402);
+      this.engineViewHost.ReadOnly = false;
+      this.engineViewHost.Size = new System.Drawing.Size(659, 335);
       this.engineViewHost.TabIndex = 2;
       this.engineViewHost.ViewType = null;
+      // 
+      // operatorGraphTabPage
+      // 
+      this.operatorGraphTabPage.Controls.Add(this.saveOperatorGraphButton);
+      this.operatorGraphTabPage.Controls.Add(this.openOperatorGraphButton);
+      this.operatorGraphTabPage.Controls.Add(this.newOperatorGraphButton);
+      this.operatorGraphTabPage.Controls.Add(this.operatorGraphViewHost);
+      this.operatorGraphTabPage.Location = new System.Drawing.Point(4, 22);
+      this.operatorGraphTabPage.Name = "operatorGraphTabPage";
+      this.operatorGraphTabPage.Size = new System.Drawing.Size(705, 441);
+      this.operatorGraphTabPage.TabIndex = 4;
+      this.operatorGraphTabPage.Text = "Operator Graph";
+      this.operatorGraphTabPage.UseVisualStyleBackColor = true;
+      // 
+      // saveOperatorGraphButton
+      // 
+      this.saveOperatorGraphButton.Enabled = false;
+      this.saveOperatorGraphButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Save;
+      this.saveOperatorGraphButton.Location = new System.Drawing.Point(63, 3);
+      this.saveOperatorGraphButton.Name = "saveOperatorGraphButton";
+      this.saveOperatorGraphButton.Size = new System.Drawing.Size(24, 24);
+      this.saveOperatorGraphButton.TabIndex = 1;
+      this.toolTip.SetToolTip(this.saveOperatorGraphButton, "Save Operator Graph");
+      this.saveOperatorGraphButton.UseVisualStyleBackColor = true;
+      // 
+      // openOperatorGraphButton
+      // 
+      this.openOperatorGraphButton.Enabled = false;
+      this.openOperatorGraphButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Open;
+      this.openOperatorGraphButton.Location = new System.Drawing.Point(33, 3);
+      this.openOperatorGraphButton.Name = "openOperatorGraphButton";
+      this.openOperatorGraphButton.Size = new System.Drawing.Size(24, 24);
+      this.openOperatorGraphButton.TabIndex = 1;
+      this.toolTip.SetToolTip(this.openOperatorGraphButton, "Open Operator Graph");
+      this.openOperatorGraphButton.UseVisualStyleBackColor = true;
+      // 
+      // newOperatorGraphButton
+      // 
+      this.newOperatorGraphButton.Enabled = false;
+      this.newOperatorGraphButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.NewDocument;
+      this.newOperatorGraphButton.Location = new System.Drawing.Point(3, 3);
+      this.newOperatorGraphButton.Name = "newOperatorGraphButton";
+      this.newOperatorGraphButton.Size = new System.Drawing.Size(24, 24);
+      this.newOperatorGraphButton.TabIndex = 1;
+      this.toolTip.SetToolTip(this.newOperatorGraphButton, "New Operator Graph");
+      this.newOperatorGraphButton.UseVisualStyleBackColor = true;
+      // 
+      // operatorGraphViewHost
+      // 
+      this.operatorGraphViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.operatorGraphViewHost.Content = null;
+      this.operatorGraphViewHost.Location = new System.Drawing.Point(3, 33);
+      this.operatorGraphViewHost.Name = "operatorGraphViewHost";
+      this.operatorGraphViewHost.ReadOnly = true;
+      this.operatorGraphViewHost.Size = new System.Drawing.Size(699, 405);
+      this.operatorGraphViewHost.TabIndex = 0;
+      this.operatorGraphViewHost.ViewType = null;
       // 
       // EngineAlgorithmView
@@ -244,4 +313,5 @@
       this.engineTabPage.ResumeLayout(false);
       this.engineTabPage.PerformLayout();
+      this.operatorGraphTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -256,4 +326,9 @@
     protected System.Windows.Forms.TabPage engineTabPage;
     protected HeuristicLab.MainForm.WindowsForms.ViewHost engineViewHost;
+    protected System.Windows.Forms.TabPage operatorGraphTabPage;
+    protected HeuristicLab.MainForm.WindowsForms.ViewHost operatorGraphViewHost;
+    protected System.Windows.Forms.Button saveOperatorGraphButton;
+    protected System.Windows.Forms.Button openOperatorGraphButton;
+    protected System.Windows.Forms.Button newOperatorGraphButton;
 
   }
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.cs	(revision 3360)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.cs	(revision 3361)
@@ -59,10 +59,12 @@
 
     protected override void DeregisterContentEvents() {
-      Content.EngineChanged -= new System.EventHandler(Content_EngineChanged);
+      Content.EngineChanged -= new EventHandler(Content_EngineChanged);
+      Content.OperatorGraphChanged -= new EventHandler(Content_OperatorGraphChanged);
       base.DeregisterContentEvents();
     }
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
-      Content.EngineChanged += new System.EventHandler(Content_EngineChanged);
+      Content.EngineChanged += new EventHandler(Content_EngineChanged);
+      Content.OperatorGraphChanged += new EventHandler(Content_OperatorGraphChanged);
     }
 
@@ -87,4 +89,5 @@
         engineViewHost.Content = null;
         createUserDefinedAlgorithmButton.Enabled = false;
+        operatorGraphViewHost.Content = null;
       } else {
         if (Content.Engine == null)
@@ -94,4 +97,6 @@
         engineViewHost.ViewType = null;
         engineViewHost.Content = Content.Engine;
+        operatorGraphViewHost.ViewType = null;
+        operatorGraphViewHost.Content = Content.OperatorGraph;
         createUserDefinedAlgorithmButton.Enabled = true;
       }
@@ -105,4 +110,5 @@
         engineComboBox.Enabled = Content.ExecutionState != ExecutionState.Started;
         engineViewHost.Enabled = Content.ExecutionState != ExecutionState.Started;
+        operatorGraphViewHost.Enabled = Content.ExecutionState != ExecutionState.Started;
         base.Content_ExecutionStateChanged(sender, e);
       }
@@ -118,4 +124,12 @@
         engineViewHost.ViewType = null;
         engineViewHost.Content = Content.Engine;
+      }
+    }
+    private void Content_OperatorGraphChanged(object sender, EventArgs e) {
+      if (InvokeRequired)
+        Invoke(new EventHandler(Content_OperatorGraphChanged), sender, e);
+      else {
+        operatorGraphViewHost.ViewType = null;
+        operatorGraphViewHost.Content = Content.OperatorGraph;
       }
     }
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.Designer.cs	(revision 3360)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.Designer.cs	(revision 3361)
@@ -45,9 +45,4 @@
     /// </summary>
     private void InitializeComponent() {
-      this.operatorGraphTabPage = new System.Windows.Forms.TabPage();
-      this.saveOperatorGraphButton = new System.Windows.Forms.Button();
-      this.openOperatorGraphButton = new System.Windows.Forms.Button();
-      this.newOperatorGraphButton = new System.Windows.Forms.Button();
-      this.operatorGraphViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
       this.globalScopeTabPage = new System.Windows.Forms.TabPage();
       this.globalScopeView = new HeuristicLab.Core.Views.ScopeView();
@@ -60,5 +55,4 @@
       this.problemPanel.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
-      this.operatorGraphTabPage.SuspendLayout();
       this.globalScopeTabPage.SuspendLayout();
       this.SuspendLayout();
@@ -72,5 +66,4 @@
       // tabControl
       // 
-      this.tabControl.Controls.Add(this.operatorGraphTabPage);
       this.tabControl.Controls.Add(this.globalScopeTabPage);
       this.tabControl.Controls.SetChildIndex(this.globalScopeTabPage, 0);
@@ -115,62 +108,4 @@
       this.errorProvider.SetIconPadding(this.nameTextBox, 2);
       // 
-      // operatorGraphTabPage
-      // 
-      this.operatorGraphTabPage.Controls.Add(this.saveOperatorGraphButton);
-      this.operatorGraphTabPage.Controls.Add(this.openOperatorGraphButton);
-      this.operatorGraphTabPage.Controls.Add(this.newOperatorGraphButton);
-      this.operatorGraphTabPage.Controls.Add(this.operatorGraphViewHost);
-      this.operatorGraphTabPage.Location = new System.Drawing.Point(4, 22);
-      this.operatorGraphTabPage.Name = "operatorGraphTabPage";
-      this.operatorGraphTabPage.Size = new System.Drawing.Size(705, 441);
-      this.operatorGraphTabPage.TabIndex = 2;
-      this.operatorGraphTabPage.Text = "Operator Graph";
-      this.operatorGraphTabPage.UseVisualStyleBackColor = true;
-      // 
-      // saveOperatorGraphButton
-      // 
-      this.saveOperatorGraphButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Save;
-      this.saveOperatorGraphButton.Location = new System.Drawing.Point(63, 3);
-      this.saveOperatorGraphButton.Name = "saveOperatorGraphButton";
-      this.saveOperatorGraphButton.Size = new System.Drawing.Size(24, 24);
-      this.saveOperatorGraphButton.TabIndex = 1;
-      this.toolTip.SetToolTip(this.saveOperatorGraphButton, "Save Operator Graph");
-      this.saveOperatorGraphButton.UseVisualStyleBackColor = true;
-      this.saveOperatorGraphButton.Click += new System.EventHandler(this.saveOperatorGraphButton_Click);
-      // 
-      // openOperatorGraphButton
-      // 
-      this.openOperatorGraphButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Open;
-      this.openOperatorGraphButton.Location = new System.Drawing.Point(33, 3);
-      this.openOperatorGraphButton.Name = "openOperatorGraphButton";
-      this.openOperatorGraphButton.Size = new System.Drawing.Size(24, 24);
-      this.openOperatorGraphButton.TabIndex = 1;
-      this.toolTip.SetToolTip(this.openOperatorGraphButton, "Open Operator Graph");
-      this.openOperatorGraphButton.UseVisualStyleBackColor = true;
-      this.openOperatorGraphButton.Click += new System.EventHandler(this.openOperatorGraphButton_Click);
-      // 
-      // newOperatorGraphButton
-      // 
-      this.newOperatorGraphButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.NewDocument;
-      this.newOperatorGraphButton.Location = new System.Drawing.Point(3, 3);
-      this.newOperatorGraphButton.Name = "newOperatorGraphButton";
-      this.newOperatorGraphButton.Size = new System.Drawing.Size(24, 24);
-      this.newOperatorGraphButton.TabIndex = 1;
-      this.toolTip.SetToolTip(this.newOperatorGraphButton, "New Operator Graph");
-      this.newOperatorGraphButton.UseVisualStyleBackColor = true;
-      this.newOperatorGraphButton.Click += new System.EventHandler(this.newOperatorGraphButton_Click);
-      // 
-      // operatorGraphViewHost
-      // 
-      this.operatorGraphViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.operatorGraphViewHost.Content = null;
-      this.operatorGraphViewHost.Location = new System.Drawing.Point(3, 33);
-      this.operatorGraphViewHost.Name = "operatorGraphViewHost";
-      this.operatorGraphViewHost.Size = new System.Drawing.Size(699, 405);
-      this.operatorGraphViewHost.TabIndex = 0;
-      this.operatorGraphViewHost.ViewType = null;
-      // 
       // globalScopeTabPage
       // 
@@ -192,4 +127,5 @@
       this.globalScopeView.Location = new System.Drawing.Point(3, 3);
       this.globalScopeView.Name = "globalScopeView";
+      this.globalScopeView.ReadOnly = false;
       this.globalScopeView.Size = new System.Drawing.Size(699, 435);
       this.globalScopeView.TabIndex = 0;
@@ -209,5 +145,4 @@
       this.problemPanel.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
-      this.operatorGraphTabPage.ResumeLayout(false);
       this.globalScopeTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
@@ -218,11 +153,6 @@
     #endregion
 
-    private System.Windows.Forms.TabPage operatorGraphTabPage;
     private System.Windows.Forms.TabPage globalScopeTabPage;
     private HeuristicLab.Core.Views.ScopeView globalScopeView;
-    private System.Windows.Forms.Button saveOperatorGraphButton;
-    private System.Windows.Forms.Button openOperatorGraphButton;
-    private System.Windows.Forms.Button newOperatorGraphButton;
-    private HeuristicLab.MainForm.WindowsForms.ViewHost operatorGraphViewHost;
 
   }
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.cs	(revision 3360)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.cs	(revision 3361)
@@ -54,23 +54,10 @@
     }
 
-    protected override void DeregisterContentEvents() {
-      Content.OperatorGraphChanged -= new EventHandler(Content_OperatorGraphChanged);
-      base.DeregisterContentEvents();
-    }
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      Content.OperatorGraphChanged += new EventHandler(Content_OperatorGraphChanged);
-    }
-
     protected override void OnContentChanged() {
       base.OnContentChanged();
-      if (Content == null) {
-        operatorGraphViewHost.Content = null;
+      if (Content == null) 
         globalScopeView.Content = null;
-      } else {
-        operatorGraphViewHost.ViewType = null;
-        operatorGraphViewHost.Content = Content.OperatorGraph;
+      else 
         globalScopeView.Content = Content.GlobalScope;
-      }
     }
 
@@ -80,15 +67,6 @@
       else {
         newOperatorGraphButton.Enabled = openOperatorGraphButton.Enabled = saveOperatorGraphButton.Enabled = Content.ExecutionState != ExecutionState.Started;
-        operatorGraphViewHost.Enabled = Content.ExecutionState != ExecutionState.Started;
         globalScopeView.Enabled = Content.ExecutionState != ExecutionState.Started;
         base.Content_ExecutionStateChanged(sender, e);
-      }
-    }
-    private void Content_OperatorGraphChanged(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Content_OperatorGraphChanged), sender, e);
-      else {
-        operatorGraphViewHost.ViewType = null;
-        operatorGraphViewHost.Content = Content.OperatorGraph;
       }
     }
Index: /trunk/sources/HeuristicLab.Optimization/3.3/EngineAlgorithm.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization/3.3/EngineAlgorithm.cs	(revision 3360)
+++ /trunk/sources/HeuristicLab.Optimization/3.3/EngineAlgorithm.cs	(revision 3361)
@@ -36,7 +36,7 @@
     [Storable]
     private OperatorGraph operatorGraph;
-    protected OperatorGraph OperatorGraph {
+    public OperatorGraph OperatorGraph {
       get { return operatorGraph; }
-      set {
+      protected set {
         if (value == null) throw new ArgumentNullException();
         if (value != operatorGraph) {
@@ -194,5 +194,9 @@
         EngineChanged(this, EventArgs.Empty);
     }
-    protected virtual void OnOperatorGraphChanged() { }
+    public event EventHandler OperatorGraphChanged;
+    protected virtual void OnOperatorGraphChanged() {
+      EventHandler handler = OperatorGraphChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
     protected override void OnStopped() {
       if (Problem != null) {
Index: /trunk/sources/HeuristicLab.Optimization/3.3/UserDefinedAlgorithm.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization/3.3/UserDefinedAlgorithm.cs	(revision 3360)
+++ /trunk/sources/HeuristicLab.Optimization/3.3/UserDefinedAlgorithm.cs	(revision 3361)
@@ -54,10 +54,4 @@
     [StorableConstructor]
     private UserDefinedAlgorithm(bool deserializing) : base(deserializing) { }
-
-    public event EventHandler OperatorGraphChanged;
-    protected override void OnOperatorGraphChanged() {
-      EventHandler handler = OperatorGraphChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
   }
 }