Index: unk/sources/HeuristicLab.Common/3.2/DeepCloneable.cs
===================================================================
--- /trunk/sources/HeuristicLab.Common/3.2/DeepCloneable.cs	(revision 3376)
+++ 	(revision )
@@ -1,60 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Core {
-  /// <summary>
-  /// Represents a base class for all deeply cloneable objects.
-  /// </summary>
-  [StorableClass]
-  public abstract class DeepCloneable : IDeepCloneable {
-    protected DeepCloneable() { }
-    [StorableConstructor]
-    protected DeepCloneable(bool deserializing) { }
-
-    /// <summary>
-    /// Creates a deep clone of this instance.
-    /// </summary>
-    /// <remarks>
-    /// This method is the entry point for creating a deep clone of a whole object graph.
-    /// </remarks>
-    /// <returns>A clone of this instance.</returns>
-    public object Clone() {
-      return Clone(new Cloner());
-    }
-
-    /// <summary>
-    /// Creates a deep clone of this instance.
-    /// </summary>
-    /// <remarks>This method should not be called directly. It is used for creating clones of
-    /// objects which are contained in the object that is currently cloned.</remarks>
-    /// <param name="cloner">The cloner which is responsible for keeping track of all already
-    /// cloned objects.</param>
-    /// <returns>A clone of this instance.</returns>
-    public virtual IDeepCloneable Clone(Cloner cloner) {
-      DeepCloneable clone = (DeepCloneable)Activator.CreateInstance(this.GetType());
-      cloner.RegisterClonedObject(this, clone);
-      return clone;
-    }
-  }
-}
Index: /trunk/sources/HeuristicLab.Optimization/3.3/RunCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization/3.3/RunCollection.cs	(revision 3376)
+++ /trunk/sources/HeuristicLab.Optimization/3.3/RunCollection.cs	(revision 3377)
@@ -27,5 +27,4 @@
 using HeuristicLab.Data;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Optimization {
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/HeuristicLabProblemsDataAnalysisViewsPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/HeuristicLabProblemsDataAnalysisViewsPlugin.cs	(revision 3376)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/HeuristicLabProblemsDataAnalysisViewsPlugin.cs	(revision 3377)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.Problems.DataAnalysis.Views {
-  [Plugin("HeuristicLab.Problems.DataAnalysis.Views","3.3.0.3373")]
+  [Plugin("HeuristicLab.Problems.DataAnalysis.Views","3.3.0.3376")]
   [PluginFile("HeuristicLab.Problems.DataAnalysis.Views-3.3.dll", PluginFileType.Assembly)]
   public class HeuristicLabProblemsDataAnalysisViewsPlugin : PluginBase {
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Dataset.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Dataset.cs	(revision 3376)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Dataset.cs	(revision 3377)
@@ -30,5 +30,4 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Data;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Problems.DataAnalysis {
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/SimpleArithmeticExpressionEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/SimpleArithmeticExpressionEvaluator.cs	(revision 3376)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/SimpleArithmeticExpressionEvaluator.cs	(revision 3377)
@@ -21,5 +21,4 @@
 
 using System;
-using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Common;